
µWeb - Bug #599

TemplateConditional doesn't restrict to tagnames

2012-01-26 17:22 - Elmer de Looff

Status: Closed Start date: 2012-01-26

Priority: Normal Due date:  

Assignee: Jan Klopper % Done: 100%

Category:  Estimated time: 0.00 hour

Target version:  Spent time: 1.00 hour

Description

TemplateConditional expressions are broken in two ways:

1. They support local variable names. That is, {{ if foo == 'bar' }} is a valid TemplateConditional expression

2. They place the repr() of the object inline in the evaluated string, this breaks for non-idempotent objects (e.g. generators)

History

#1 - 2012-01-26 17:24 - Elmer de Looff

- Status changed from In Progress to Resolved

- Assignee changed from Elmer de Looff to Jan Klopper

- % Done changed from 30 to 70

This has been fixed by replacing tagnames in TemplateConditional statements by local placeholders, that get mapped to their own local_vars

dictionary, which is provided to eval(locals=). Whenever an unknown name is encountered, TemplateNameError is raised.

A testcase for this has been added to the test suite.

#2 - 2012-02-28 11:15 - Elmer de Looff

- Status changed from Resolved to Closed

- % Done changed from 70 to 100

Working as intended. (no idea why I assigned this away)
